Advanced roadmap - Error #268

Wrong labels in roadmap for "Due in" values
2010-04-28 11:38 - Sebastian Mehner

Status: Resolved Start date: 2010-04-28
Priority: Normal Due date: 2010-08-23
Assignee: Emilio Gonzalez Montafia % Done: 100%
Category: Roadmap Estimated time: 0.00 hour
Target version: Advanced roadmap 0.1.0

Source: Redmine version:

Detected on version:

Description

| have the problem, that all of the "Due in" values in Advanced Roadmap are labeled as hours. | don't quite know how this error
evolves since the labels here in your project are correct "hours/days/weeks". I'm running Redmine 0.9.2.

Any suggestions?

Associated revisions

Revision a741ca16 - 2010-08-23 12:05 - Emilio Gonzalez Montaina
#268

e Corrected due dates (days and weeks) adding a patch to the Redmine::[18n module.

History

#1 - 2010-08-19 10:29 - Andrew Rudenko
- File projects_roadmap.png added
- File versions_show.png added

- File milestones_show.png added

I've resolved this issue by modifying the existing code and extending i18n.rb Redmine's lib.

First, modify show.rhtml for milestones and versions views, and roadmap.rhtml for projects view inside of
J/vendor/plugins/advanced_roadmap/app/views by providing /_days and |_weeks functions

Index: vendor/plugins/advanced_roadmap/app/views/milestones/show.rthml

@@ -58,1 +58,1 @@
<td width="340px" class="total-hours"><
= "#{1_hours (rest_hours)} / #{1l_hours(rest_hours / 8.0)} / #{1l_hours(rest_hours / 40.0)}" $></td>
<td width="340px" class="total-hours"><
"#{1_hours (rest_hours)} / #{l_days(rest_hours / 8.0)} / #{1l_weeks (rest_hours / 40.0)}" $></td>
Index: vendor/plugins/advanced_roadmap/app/views/projects/roadmap.rthml

o |
-49,1 +49,1 @@
<td width="340px" class="total-hours"><
"#{1_hours (rest_hours)} / #{1l_hours(rest_hours / 8.0)} / #{1l_hours(rest_hours / 40.0)}" %></td>
<td width="340px" class="total-hours"><
= "#{1_hours (rest_hours)} / #{1l_days(rest_hours / 8.0)} / #{1l_weeks(rest_hours / 40.0)}" $></td>
Index: vendor/plugins/advanced_roadmap/app/views/versions/show.rthml

I
@
@@ -26,1 +26,1 Q@
- <td width="240px" class="total-hours"><

%= "#{1_hours (Qversion.rest_hours)} <br/> #{1l_hours (@version.rest_hours / 8.0)} <br/> #{1l_hours (@version.rest_
hours / 40.0)}" $></td>

+ <td width="240px" class="total-hours"><

%= "#{1_hours (@version.rest_hours)} <br/> #{1l_days(@version.rest_hours / 8.0)} <br/> #{1l_weeks (Qversion.rest_h

ours / 40.0)}" %></td>

Second, modify locales YAML file(s) to properly display output values from /_days and |_weeks functions inside of
vendor/plugins/advanced_roadmap/config/locales
Index: vendor/plugins/advanced_roadmap/config/locales/en.yml

@@ -2,4 +2,4 @@

- label_f_day: %.2f day

- label_f_day_plural:

%.2f days

- label_f_week: %.2f week

label_f_week_plural:

%.2f weeks

+ label_ f_day: "{{value}} day"

+ label_f_day_plural: "{{value}} days"

+ label_f_week: "{{value}} week"

+ label_f_ week_plural: "{{value}} weeks"

Third, extend i18b.rb Redmine's library with /_days and |_weeks functions inside of lib/redmine

Index: lib/redmine/il8n.rb

@@ -29,8 +29,18 @@

def 1_hours (hours)

hours = hours.to_f
:label_f_hour : :label_f_hour_plural), :value => ("%.2f" $ hours.to_f))

1((hours < 2.0 ?

end

end

end

+ + + F o+ o+ A+ o+ +

def 11 (lang, str,

def 1_days (days)
days = days.to_f
l((days < 2.0 ?

def 1_weeks (weeks)
weeks = weeks.to_f
1((weeks < 2.0 ?

:label_f_day : :label_f_day_plural),

:value => ("%$.2f" % days.to_f))

:label_f_week : :label_f week_plural), :value => ("%$.2f" & weeks.to_f))

value=nil)

::I18n.t(str.to_s, :value => value, :locale => lang.to_s.gsub(%r{(.+)\=(.+)$}) { "#{S$1l}-#{S$2.upcase}"

end

Of course, we might create/extend helpers for milestones, projects and versions with [_days and |_weeks functions but | prefer to extend i18n.rb
instead due to leak of experience how to extend helpers :).

Fourth, restart your application server (webrick, mongrel, apache+mod_passenger, etc.) and Enjoy!

Roadmap

Total

Time tracking

Estimated time 759.00 hours
Spent time 357.40 hours
% Done <4 1o

Due in 505.17 hours / 63.15 days / 12.63 weeks

Tirme tracking
Estimated time
Spent time

% Done

Due in
4 Edit

275.00 hours
86.10 hours
4o

262.00 hours
32.75 days
6.55 weeks
Milestone 1

0B/19/2010

Milestone 1

Total

0%
Time tracking
Estimated time 0.00 hour
Spent time 0.00 hour
% Done Dogp
Due in 0.00 hour / 0.0 day / 0.00 week

#2 - 2010-08-19 11:56 - Andrew Rudenko

Updated Third action:
as | said before, we may not modify i18n.rb Redmine's library but put all necessary code into plugin helpers.

I'm a newbie in Ruby on Rails so sorry if do something wrongly. | understand that the code below conflicts with DRY principals of the RoR but don't
know how to force this code work in compliance to DRY.
so what | have,

Third, create helpers inside of plugin folder, and add /_days and |_weeks functions there
vendor/plugins/advanced_roadmap/app/helpers/milestones_helper.rb

module MilestonesHelper

def 1_days (days)
days = days.to_f

l((days < 2.0 ? :label_f_day : :label_f_ day_plural), :value => ("%.2f" % days.to_f))
end

def 1_weeks (weeks)
weeks = weeks.to_f

1((weeks < 2.0 ? :label_f_week : :label_f_week_plural), :value => ("%.2f" % weeks.to_f))
end

end

vendor/plugins/advanced_roadmap/app/helpers/projects_helper.rb

module ProjectsHelper

def 1_days (days)
days = days.to_f

l((days < 2.0 ? :label_f_day : :label_f_day_plural), :value => ("%.2f" % days.to_f))
end

def 1_weeks (weeks)
weeks = weeks.to_f
1((weeks < 2.0 ? :label_f_week : :label_f week_plural), :value => ("%.2f" $ weeks.to_f))

end

end

vendor/plugins/advanced_roadmap/app/helpers/versions_helper.rb

module VersionsHelper

def 1_days (days)

days = days.to_f

l((days < 2.0 ? :label_f_day : :label_f_day_plural), :value => ("%$.2f" % days.to_f))
end

def 1_weeks (weeks)

weeks = weeks.to_f
1((weeks < 2.0 ? :label_f week : :label_f_ week_plural), :value => ("%.2f" % weeks.to_f))
end
end
#3 - 2010-08-23 13:44 - Emilio Gonzalez Montaha

- Status changed from New to In progress

- Target version set to Advanced roadmap 0.1.0

#4 - 2010-08-23 14:06 - Emilio Gonzalez Montana
- Due date set to 2010-08-23
- Status changed from In progress to Resolved

- % Done changed from 0 to 100

Thanks Andrew.
